/*****************************************************************
;*        Sample SFR/Vector File for TLCS-870/C1 Series          *
;*               Memory Style: Within 64K byte                   *
;*---------------------------------------------------------------*
;*  (C)Copyright TOSHIBA CORPORATION 2008  All rights reserved   *
;*****************************************************************/
//#define IO_MEM    1


#include "MQ6822.h"


void startup(void);	//defined by startup.asm
/*========================================================
  [ Declare interrupt function ]
  ========================================================*/
void __interrupt Int2(void);
void __interrupt Int3(void);
void __interrupt Int4(void);
void __interrupt IntTC00(void);
void __interrupt IntTC01(void);
void __interrupt IntTC02(void);
void __interrupt IntTC03(void);
void __interrupt IntTC04(void);
void __interrupt IntTC05(void);
void __interrupt IntTCA0(void);
void __interrupt IntRTC(void);
void __interrupt IntADC(void);
void __interrupt IntVLTD(void);
void __interrupt IntRXD1(void);
void __interrupt IntTXD1(void);
void __interrupt IntSBI(void);
void __interrupt IntSIO0(void);
void __interrupt IntTBT(void);
void __interrupt IntWUC(void);
void __interrupt_n IntWDT(void);
void __interrupt_n IntSWI(void);


/*========================================================
  [ Dummy function for interrupt ]
  ========================================================*/
void __interrupt		Int_dummy(void){ }
void __interrupt_n		Int_n_dummy(void){ }

/*========================================================
  [ Implement interrupt function]
  ========================================================*/
void __interrupt Int2(void)
{
	//Add your interrupt handler code here
}
void __interrupt Int3(void)
{
	//Add your interrupt handler code here
}
void __interrupt Int4(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTC00(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTC01(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTC02(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTC03(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTC04(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTC05(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTCA0(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntRTC(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntADC(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntVLTD(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntRXD1(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTXD1(void)
{
	//Add your interrupt handler code here
}

unsigned char value[16];
unsigned char address[2];
unsigned char F_addr=0;
unsigned char F_SecondByte=0;
unsigned char Flag=0;
unsigned char bytes=0;
unsigned char cnt=0;

void __interrupt IntSBI(void)
{
	Flag  = SBI0SR2.byte;
	Flag &= 0x4E;

	if(Flag==0x04||Flag==0x06)
	{
		F_addr = 0xff;		// ӻַƥ
		SBI0DBR.byte = 0;
		bytes = 0;
	}

	else if(Flag==0x00||Flag==0x02)	// slave
	{
		if(F_addr)
		{
			address[0]   = SBI0DBR.byte;
			SBI0DBR.byte = 0;
			F_addr       = 0;
			F_SecondByte = 0;
		}
		if( address[0]==0x55 && F_SecondByte ) //Ŀַƥ
		{
			value[bytes] = SBI0DBR.byte;
			SBI0DBR.byte = 0;
			bytes++;

			if( bytes == 16 )
			{
				bytes = 0;
			}
		}
		else if(address[0]==0x55)	F_SecondByte = 0xff;
		else
		{	                        // Ŀַƥ
			// SBI0CR1.byte=0x07;	//  <BCV>=000 <ACK>=0Ӧ
			SBI0DBR.byte=0x0;		// PINΪ1
			//while(SBI0SR2.bit.b4);// ȴʱӷ  PINΪ0   ///////////////////////////////
		}
	}

	else if(Flag==0x4C)
	{	// bus źŲͻ master
		cnt=0;
		if(address[0]==0x55) SBI0DBR.byte = value[cnt++];
	}

	else if(Flag==0x44)
	{
		cnt=0;
		if(address[0]==0x55) SBI0DBR.byte = value[cnt++];	// ͵һֽ
		else				 SBI0DBR.byte = 0; 				// Ŀַƥ 0

		while(SBI0CR2.bit.b4);
	}	// master

	else if (Flag==0x40)	// slave
	{
		if(SBI0SR2.bit.b0==1)
		{
			SBI0CR2.byte = 0x18;	// ִк
		}	// Ӧ  ڴһֽ
		else
		{      				        // Ӧ
			if(address[0]==0x55)	// Ŀַƥ
			{
				SBI0DBR.byte = value[cnt++];
				while(SBI0CR2.bit.b4);

				if( cnt == 16 ) cnt = 0;
			}
			else
			{
				SBI0DBR.byte = 0;         //Ŀַƥ 0
				while(SBI0CR2.bit.b4);
			}
		}
	}

	else if( Flag==0x0C || Flag==0x0E )
	{
		SBI0DBR.byte = 0;
	}

	else if(Flag==0x08)
	{
		SBI0DBR.byte = 0;
	}
}

void __interrupt IntSIO0(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntTBT(void)
{
	//Add your interrupt handler code here
}
void __interrupt IntWUC(void)
{
	//Add your interrupt handler code here
}
void __interrupt_n IntWDT(void)
{
	//Add your interrupt handler code here
}
void __interrupt_n IntSWI(void)
{
	//Add your interrupt handler code here
	unsigned char tmp;
	tmp =*(unsigned char*)(0xf000);
	while(tmp != *(unsigned char*)(0xf000))
	{
		tmp =*(unsigned char*)(0xf000);

	}
	SYSCR2.byte=0x10;	//system clock reset
}
/*============================================
  [ Define interrupt table ]
    This part must be rewrite.
  ============================================*/
#pragma section const INT_VECTOR1
void * const IntTbl1[] = {
	IntTC05,			/* 0xffc4 : IntTC05 */
    IntTC04,			/* 0xffc6 : IntTC04 */
	(void *)0xffff,		/* 0xffc8 : Reserved */
    (void *)0xffff,		/* 0xffca : Reserved */
    IntTC03,			/* 0xffcc : IntTC03 */
    IntTC02,			/* 0xffce : IntTC02 */
    IntTXD1,			/* 0xffd0 : IntTXD1 */
    IntRXD1,			/* 0xffd2 : IntRXD1 */
    Int_dummy,			/* 0xffd4 : Reserved */
    Int4,				/* 0xffd6 : Int4 */
    Int3,				/* 0xffd8 : Int3 */
    Int2,				/* 0xffda : Int2 */
    Int_dummy,			/* 0xffdc : Reserved */
    Int_dummy,			/* 0xffde : Reserved */
    IntSBI,				/* 0xffe0 : IntSBI */
    IntTCA0,			/* 0xffe2 : IntTCA0  */
    IntTC01,			/* 0xffe4 : IntTC01 */
    IntTC00,			/* 0xffe6 : IntTC00 */
    IntRTC,				/* 0xffe8 : IntRTC */
    IntADC,				/* 0xffea : IntADC */
    IntVLTD,			/* 0xffec : IntVLTD */
    Int_dummy,			/* 0xffee : Reserved */
    Int_dummy,			/* 0xfff0 : Reserved */
    IntSIO0,			/* 0xfff2 : IntSIO0 */
    IntTBT,				/* 0xfff4 : IntTBT */
    IntWUC,	    		/* 0xfff6 : IntWUC */
    IntWDT,				/* 0xfff8 : IntWDT */
    (void *)0xffff,		/* 0xfffa : Reserved */
    IntSWI,	   			/* 0xfffc : IntSWI/INTUNDEF */
    startup		    	/* 0xfffe : RESET */
};
#pragma section const   /* return to default */
